;Thank you
;Jim Alverson   email: jima@tso.org

#include "asm86.h"
#include "ti86asm.inc"

_user_int_ram EQU $d2fd                 ;Area where interrupt handler goes..

.org _asm_exec_ram
   res 2,(iy+$23)                       ;turn user int off so it won't get called by
                                        ;accident before we're ready
   
   ld hl,int                            ;copy prog to user int buffer
   ld de,_user_int_ram+1
   ld bc,int_end-int                    ;length of handler
   ldir                                 ;hl is the source, de is the destination,
                                        ;and bc is the length
   
   ld a,(_user_int_ram+1)               ;set up checksum byte
   ld hl,_user_int_ram+($28*1)          ;load byte
   add a,(hl)                           ;add to total
   ld hl,_user_int_ram+($28*2)          ;load byte
   add a,(hl)                           ;add to total
   ld hl,_user_int_ram+($28*3)          ;load byte
   add a,(hl)                           ;add to total
   ld hl,_user_int_ram+($28*4)          ;load byte
   add a,(hl)                           ;add to total
   ld hl,_user_int_ram+($28*5)          ;load byte
   add a,(hl)                           ;add to total
   ld (_user_int_ram),a                 ;load checksum in its location

   set 2,(iy+$23)                       ;turn it on
   ret


int:
   push af                              ;save registers.. MUST DO.. your calculator
   push hl                              ;will crash if you don't
   push bc
 	in a,(3)
	bit 3,a										;was on pressed?
	jr nz,exit									;if not, quit
	bit 1,a										;is display off?
	jr z,on										;if so, turn it on
	ld a,%00001011
	out (3),a									;turn LCD off
	jr exit
on:
	ld	a,%00000011
	out (3),a									;turn LCD on
exit:
   pop bc                               ;restore saved registers
   pop hl
   pop af
   ret                                  ;returns

int_end:

.end

